#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/types.h>
#include <pwd.h>
#include <stdio.h>

int main(int argc, char **argv, char **envp)
{
  char *buffer;
  struct passwd *passwd;

  gid_t gid;
  uid_t uid;

  gid = getegid();
  uid = geteuid();

  setresgid(gid, gid, gid);
  setresuid(uid, uid, uid);

  buffer = NULL;
  passwd = getpwuid(getuid());
  if (passwd == NULL) {
    perror("getpwuid()");
    exit(EXIT_FAILURE);
  }

  asprintf(&buffer, "/bin/echo %s is cool", passwd->pw_name);
  printf("about to call system(\"%s\")\n", buffer);

  system(buffer);
}
